TYPO3.Flow - Bug # 52944

Status: Resolved Priority: Should have
Author: Hendrik Frahmann Category:

Created: 2013-10-18 Assigned To:

Updated: 2014-07-11 Due date:

PHP Version:

Has patch: No

Complexity:

Affected Flow version: Git master

Subject: Generating correct proxy classes for classes without a namespace

Description

When packages (that are loaded with composer to Libraries) containing classes without a namespace, Flow generates a corrupt proxy
class.

class FooClass_Original {

}

namespace ; / empty namespace causing error
// Parse error: syntax error, unexpected ';', expecting T_STRING or T_NS_SEPARATOR or '{" in [filename]

class FooClass {
// proxy class

}

Related issues:
related to TYPOS.Flow - Bug # 52945: Excluded classes should only be excluded... New 2013-10-18

Associated revisions

Revision 9352bf3f - 2014-01-06 11:33 - Alexander Berl

[BUGFIX] Classes without namespace create invalid proxy code

This change makes classes without namespace create proper proxy
class code, by optionally skipping the namespace declaration.
Before such classes would create an empty namespace statement,
which resulted in syntax errors, i.e.::

namespace ;

=> "syntax error, unexpected ';', expecting T_STRING or
T_NS_SEPARATOR or '{"in [filename]"

Change-Id: 1a7130b24ab149f00ac318c¢809c698db7c20934ch
Fixes: #52944
Releases: master, 2.0

Revision 649c3fa3 - 2014-01-14 12:02 - Alexander Berl
[BUGFIX] Classes without namespace create invalid proxy code

This change makes classes without namespace create proper proxy
class code, by optionally skipping the namespace declaration.
Before such classes would create an empty namespace statement,
which resulted in syntax errors, i.e.:

namespace ;

=> "syntax error, unexpected ';', expecting T_STRING or
T_NS_SEPARATOR or '{"in [filename]"

Change-Id: 1a7130b24ab149f00ac318c¢809c698db7c20934ch
Fixes: #52944
Releases: master, 2.0

Revision d9e103d2 - 2014-01-16 10:57 - Alexander Berl

[BUGFIX] Classes without namespace create invalid proxy code

This change makes classes without namespace create proper proxy
class code, by optionally skipping the namespace declaration.
Before such classes would create an empty namespace statement,
which resulted in syntax errors, i.e.:

namespace ;

=> "syntax error, unexpected ';', expecting T_STRING or
T_NS_SEPARATOR or {"in [filename]"

Change-Id: 1a7130b24ab149f00ac318c809c698db7¢c20934cb

Fixes: #52944
Releases: master, 2.1, 2.0

History

#1 - 2013-10-18 11:33 - Philipp Maier

A real example would be this:

https://gist.github.com/hfrahmann/7037897#file-flow-cache-chromephp-php-L15

#2 - 2013-10-18 11:53 - Alexander Berl

Should be trivial to fix with an if condition. See Object/Proxy/ProxyClass::render() line 195 ff.:

$classCode = "namespace $namespace;\n" .

#3 - 2013-10-19 19:02 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.

It is available at https://review.typo3.0rg/24904
https://gist.github.com/hfrahmann/7037897#file-flow-cache-chromephp-php-L15
https://review.typo3.org/24904

#4 - 2013-10-19 19:10 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/24904

#5 - 2014-01-06 11:33 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.

It is available at https://review.typo3.org/24904

#6 - 2014-01-06 11:35 - Alexander Berl
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:9352bf3{8d582091dc0ba432c50c31b1ae917e25.

#7 - 2014-01-14 12:02 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch 2.0 of project Packages/TYPO3.Flow has been pushed to the review server.

It is available at https://review.typo3.org/26799

#8 - 2014-01-16 10:57 - Gerrit Code Review

Patch set 1 for branch 2.1 of project Packages/TYPO3.Flow has been pushed to the review server.

It is available at https://review.typo3.0rg/26871

#9 - 2014-07-11 20:19 - Alexander Berl

- Status changed from Under Review to Resolved

Applied in changeset commit:649c3fa310aa6dad60e6d4al4b36532ac4772f42.
